# cesto postoji potreba da direktno iz
# obicnog stringa napravimo sympy izraz

# da bismo to uradili potrebna su nam dva metoda
import sympy as smp
from sympy.parsing.sympy_parser import parse_expr

# na primer, neka je dat string
s = "2*x + 5"

# prebacujemo ga u sympy izraz
expr = smp.sympify(s)
smp.pretty_print(expr)

# na primer, mozemo da izracunamo izraz u tacki 5
x = smp.symbols("x")
smp.pretty_print(expr.subs(x, 5))

# na primer, ako je dat numericki izraz poput
t = "3/2 + 5/3"
# i pokusamo da ga prebacimo u sympy oblik
expr = smp.sympify(t)
# odmah cemo dobiti izracunatu vrednost
smp.pretty_print(expr)

# medjutim, ako ne zelimo da se racunanje izraza odmah desava
# prilikom konverzije, treba da prosledimo drugi argument
# evaluate=False
expr = smp.sympify(t, evaluate=False)
# i sada se nece izvrsavati automatsko racunanje tokom konverzije izraza
smp.pretty_print(expr)


# drugi nacin kako mozemo da prebacujemo stringove u sympy izraze
# mozemo da koristimo i parse_expr koji radi vrlo slicno
# na primer, neka je dat string
s = "2*x + 5"

# prebacujemo ga u sympy izraz
expr = parse_expr(s)
smp.pretty_print(expr)


# na primer, ako je dat numericki izraz poput
t = "3/2 + 5/3"
# i pokusamo da ga prebacimo u sympy oblik
expr = parse_expr(t)
# odmah cemo dobiti izracunatu vrednost
smp.pretty_print(expr)

# medjutim, ako ne zelimo da se racunanje izraza odmah desava
# prilikom konverzije, treba da prosledimo drugi argument
# evaluate=False
expr = parse_expr(t, evaluate=False)
# i sada se nece izvrsavati automatsko racunanje tokom konverzije izraza
smp.pretty_print(expr)


# razlika izmedju sympify i parse_expr je sledeca:
# sympify - u pozadini koristi eval() funkciju iz pajtona koja se koristi
#           za izvrsvanje komandi, pa je zbog toga vrlo opasna sa bezbednosne strane.
# parse_expr - bezbednija varijanta koja interno ne koristi eval() funkciju. 