import sympy as smp

# kreiramo simbole
x,y = smp.symbols("x y")

# kreiramo izraze
expr1 = 2*x
expr2 = x/(x**2 + 2*x + 1)
expr3 = x + y
expr4 = 4*x**3
expr5 = smp.cos(x)
expr6 = smp.sin(x)
expr7 = smp.exp(-x)

# da bismo odredili intergal neke funkcije treba da 
# koristimo metod integrate. prvi parametar je izraz
# a drugi je simbol po kojem integralimo
# (podrazumevano je c = 0)
smp.pretty_print(smp.integrate(expr1, x))
# ako nam treba vrednost odredjenog integrala kao treci
# parametar treba da prosledimo granice integracije
smp.pretty_print(smp.integrate(expr1, (x, 0, 2)))

# slozeniji izraz
smp.pretty_print(smp.integrate(expr2, x))
# ako nam treba dvostruki integral izraza, kao treci parametar navescemo simbol
# po kojem radimo drugu integraciju 
smp.pretty_print(smp.integrate(expr2, x, x))

# ako imamo funkciju vise promenljivih isti je postpuak
smp.pretty_print(smp.integrate(expr3, x)) # integracija po x
smp.pretty_print(smp.integrate(expr3, y)) # integracija po y
smp.pretty_print(smp.integrate(expr3, x, y)) # integracija po x, pa po y
# odredjeni integral
smp.pretty_print(smp.integrate(expr3, (x, 0, 2), (y, 0, 1)))

# mozemo da probam da izracunamo odredjeni integral od 0 do beskonacno (smp.oo)
smp.pretty_print(smp.integrate(expr7, (x, 0, smp.oo)))