import sympy as smp

# kreiramo simbole 
x,y = smp.symbols("x y")

# kreiramo izraze
expr1 = smp.cos(x)
expr2 = smp.sin(x)

# racunamo vrednosti funkcije za konkretne vrednosti x
# kao i u svim paketima i programskim jezicima, trigonometrijske
# funkcije koriste radijane
smp.pretty_print(expr1.subs(x, smp.pi))
# dobicemo tacnu vrednost, a ne numericku vrednost
smp.pretty_print(expr2.subs(x, smp.pi/4))
# ako nam treba numericka vrednost simbolicke konstante, mozemo
# da koristimo funkciju N. prvi argument je simbolicka konstanta, a 
# drugi argument je broj decimala koje zelimo
smp.pretty_print(smp.N(expr2.subs(x, smp.pi/4), 200))

# ako zelimo da koristimo funkcije sa stepenima, prvo treba da ih prebacimo
# u radijane. to mozemo lako da uradimo uz pomoc metoda radians iz paketa 
# mpmath (dolazi zajedno sa sympy)
from mpmath import radians

# s obzirom da radians daje numericku aproksimaciju stepeni u radijanima
# kao rezultat poziva dobicemo numericku, a ne simbolicku vrednost
smp.pretty_print(expr2.subs(x, radians(45)))

# ukoliko imamo zadat neki trigonomatrijski izraz mozemo da ga uprostimo
# pomocu trigsimp() metoda
expr3 = smp.sin(x)**3 + smp.cos(x)**2*smp.sin(x)
print(smp.trigsimp(expr3))
