import sympy as smp

# kreiramo matricu na slican nacin kao i do sada
mat1 = smp.Matrix([[1,2,3],[4,5,6],[8,8,9]])

# prikazujemo matricu
smp.pretty_print(mat1)

# pristup elementima matrice je moguc na dva nacina
smp.pretty_print(mat1[5])    # preko rednog broja elementa
smp.pretty_print(mat1[1,2])  # standardnim indeksiranjem

# mozemo da izdvajamo redove i kolone iz matrice
smp.pretty_print(mat1.row(1))
smp.pretty_print(mat1.col(1))

# na isti nacin mozemo i da promenimo samo jedan element matrice
mat1[1,2] = smp.sqrt(2)
smp.pretty_print(mat1)

# mozemo da dodajemo redove i kolone nasoj matrici
# prvi argument je gde dodajemo red/kolonu, a drugi argument je Matrix objekat
mat1 = mat1.row_insert(2, smp.Matrix([[1,2,3]])) # dodavanje nije u mestu, pa moramo da dodelimo vrednost
smp.pretty_print(mat1)

# dodajemo kolonu u sred matrice
mat1 = mat1.col_insert(1, smp.Matrix([[7],[8],[9],[10]]))
smp.pretty_print(mat1)

# na slican nacin mozemo i da obrisemo red/kolonu pomocu metoda 
# row_del() i col_del()
# za razliku od xx_insert(), xx_del() metode rade u mestu
mat1.row_del(3) 
mat1.col_del(2)

# ako nam treba vektor kolona kreiramo je na sledeci nacin
vkolona = smp.Matrix([[1],[2],[3]])
smp.pretty_print(vkolona)

# ako nam treba vektor kolona kreiramo je na sledeci nacin
rkolona = smp.Matrix([[1,2,3]])
smp.pretty_print(rkolona)

# transponovanje
matT = mat1.T
smp.pretty_print(matT)

# determinanta
smp.pretty_print(matT.det())

# inverzna matrica
matI = mat1.inv()
smp.pretty_print(matI)

# matricne operacije
zbir = mat1 + matT
smp.pretty_print(zbir)
razlika = mat1 - matT
smp.pretty_print(razlika)
proizvod = mat1 * matT
smp.pretty_print(proizvod)
