# do sada smo sva crtanja radili uz pomoc matplotlib-a
# medjutim, matplotlib crta podatke, dok u sympy radimo
# sa izrazima.
# 
# Pesacki nacin crtanja bi bio da prvo evaluiramo izraze
# na podeli koju bismo napravili, pa onda da crtamo sve 
# kao i do sada. Ovaj pristup je nefleksibilan i vrlo 
# nezgodan.
#
# Drugi pristup je mnogo fleksibilniji. Sympy u sebi vec 
# paket plotting koji omogucava vrlo elegantno crtanje na
# osnovu vec postojecih izraza. Paker interno koristi
# matplotlib i sintaksa je vrlo slicna
import sympy as smp
import sympy.plotting as plt


# definisemo funkciju koju zelimo da nacrtamo
x = smp.symbols("x")

# crtamo grafike funkcija
p1 = plt.plot(x*x, show=False)
p2 = plt.plot(x, show=False)
# mozemo da dodamo prvi crtez figure p2 na figuru p1
p1.append(p2[0])

# i na kraju da ih prikazemo
p1.show()

# sta se desava u slucaju kada druga figura ima vise crteza
# tada treba da koristimo metod extend

# crtamo grafike funkcija
p3 = plt.plot(x*x, show=False)
p4 = plt.plot(x, -x, show=False)
# mozemo da dodamo prvi crtez figure p2 na figuru p1
p3.extend(p4)
# i na kraju da ih prikazemo
p3.show()

# cesto postoji potreba da definisemo granice u okviru kojih crtamo nas grafik
p5 = plt.plot(x, x**2, x**3, (x, -5, 5))
p5.show()

# medjutim sta ako malo zelimo da uredimo nas grafik
p6 = plt.plot(x, (x, -5, 5), show=False, legend=True, title="Formatirani grafik", xlabel="x", ylabel="y")
p6[0].label = r"$x$"
p7 = plt.plot(x**2, (x, -5, 5), show=False, legend=True)
p7[0].label = r"$x^2$"
p8 = plt.plot(x**3, (x, -5, 5), show=False, legend=True)
p8[0].label = r"$x^3$"
p6.append(p7[0])
p6.append(p8[0])
p6.show()
