# mozemo da crtamo i parametarske krive u ravni
import sympy as smp
import sympy.plotting as plt

# mozemo da nacrtamo krug
# parametrizacija kruga je: (r*cos(t), r*sin(t))

# kreiramo simbol
t = smp.symbols("t")
# kreiram izraz koji parametarski opisuje krug poluprecnika 2
expr = (2*smp.cos(t), 2*smp.sin(t))

# crtamo krug poluprecnika 2
p1 = plt.plot_parametric(expr, (t, 0, 2*smp.pi), grid=True, show=False)
p1.show()

# na istom grafiku mozemo da crtamo i vise parametarskih krivih
cx = (t, smp.cos(t))
cy = (smp.cos(t), t)

p2 = plt.plot_parametric(expr, cx, (t, -2*smp.pi, 2*smp.pi), show = False)
p2.show()

# za svaku krivu mozemo da zadajemo razlicite intervale za parametar
p3 = plt.plot_parametric((2*smp.cos(t), 2*smp.sin(t), (t, 0, 2*smp.pi)), (smp.cos(t), t, (t, -2*smp.pi, 2*smp.pi)), show = False)
p3.show()

# vrlo lako mozemo da formatiramo grafik
cx = (t, smp.cos(2*smp.pi*t)/2 + 1/2)
sx = (t, smp.sin(2*smp.pi*t)/2 + 1/2)
p4 = plt.plot_parametric(cx, sx, (t, 0, 1), show=False, legend=True)
p4[0].line_color = "red"
p4[1].line_color = "green"
p4.show()