# kao sto smo parametarski crtali krive u ravni, 
# mozemo da crtamo parametarski zadate krive i povrsi i u prostoru
import sympy as smp
import sympy.plotting as plt

# kreiramo simbole
u, v = smp.symbols("u v")

# crtamo heliks
# parametrizacija heliksa je (a*cos(u), a*sin(u), b*u)
p1 = plt.plot3d_parametric_line(3*smp.cos(u), 3*smp.sin(u), 0.5*u, (u, -5, 5))

# na isti nacin kao i do sada mozemo da crtamo vise linija na istom grafiku

p2 = plt.plot3d_parametric_line(
    (3*smp.cos(u), 3*smp.sin(u), 0.5*u, (u, -5, 5)),
    (smp.cos(u), smp.sin(u), u, (u, -5, 5))
    )


# mozemo da nacrtamo obrtno telo koje nastaje rotacijom funkcije
# f(x) = x^2
fx = v**2

# oko x ose
# parametrizacija: (x, f(x)*cos(u), f(x)*sin(u))
p3 = plt.plot3d_parametric_surface(
    v, fx*smp.cos(u), fx*smp.sin(u), (u, 0, 2*smp.pi), (v, 0, 4)
)

# oko y ose
# parametrizacija: (inv(f)*cos(u), v, inv(f)*sin(u))

# prvo odredjujemo inverznu funkciju
invfx = smp.sqrt(v)
p4 = plt.plot3d_parametric_surface(
    invfx*smp.cos(u), v, invfx*smp.sin(u), (u, 0, 2*smp.pi), (v, 0, 4)
)