# razvicemo funkcije e^x oko 0 u tejlorov red
import sympy as smp

# kreiramo simbole
x,y = smp.symbols("x,y")

# definisemo stepen tejlorovog polinoma
n = 20
# odredjujemo tacku oko koje radimo razvijanje
x0 = 0

# definisemo funkciju
func = smp.exp(x)
# definisemo pocetnu vrednost aproksimacije kao vrednost funkcije u tacki
result = func.subs(x, x0)

# u petlji racunamo aproksimaciju funkcije oko tacke 0
for i in range(1, n):
    # konstruisemo tejlorov polinom na osnovu dobro poznate formule
    result += smp.diff(func, x, i).subs(x, x0)*((x-x0)**i)/smp.factorial(i)
    # racunamo gresku oko tacke 3
    rel_error = (func.subs(x,3) - result.subs(x,3))/func.subs(x,3)
    print("Error: ", float(rel_error))
    
# stampamo konstruisani tejlorov polinom
smp.pretty_print(result)